import { toRefs as J, defineAsyncComponent as e, computed as c, ref as o, onMounted as Y, watch as O, shallowReactive as Z, openBlock as N, createElementBlock as R, createElementVNode as w, createVNode as tt, createTextVNode as et, toDisplayString as ot, unref as it, createBlock as at, resolveDynamicComponent as nt, mergeProps as rt, toHandlers as lt, createSlots as st, renderList as ut, withCtx as ct, renderSlot as gt, normalizeProps as pt, guardReactiveProps as mt } from "vue";
import dt from "./BaseIcon-CbpX2G1z.js";
const Vt = {
  key: 0,
  style: { width: "100%", display: "flex", gap: "6px", "align-items": "center", color: "#FF0000" }
}, Ut = { style: { width: "36px" } }, ht = {
  __name: "vue-data-ui",
  props: {
    component: { type: String },
    dataset: { type: [Object, Array, Number, String] },
    config: { type: Object }
  },
  emits: [
    "selectLegend",
    "selectDatapoint",
    "toggleOpenState",
    "saveAnnotations",
    "selectRoot",
    "selectBranch",
    "selectNut",
    "change",
    "selectPlot",
    "selectSide",
    "rate",
    "postImage",
    "hoverIndex",
    "selectX",
    "toggleLock",
    "toggleTooltip",
    "start",
    "play",
    "pause",
    "reset",
    "restart",
    "lap",
    "toggleAnnotator"
  ],
  setup(F, { expose: G, emit: M }) {
    const n = F, { component: W, dataset: X, config: Q } = J(n), s = {
      VueUi3dBar: e(() => import("./vue-ui-3d-bar-anfzldet.js")),
      VueUiAgePyramid: e(() => import("./vue-ui-age-pyramid-LkSWkIF-.js")),
      VueUiAnnotator: e(() => import("./vue-ui-annotator-hg0hrQ4M.js")),
      VueUiCandlestick: e(() => import("./vue-ui-candlestick-CmOe5S2a.js")),
      VueUiChestnut: e(() => import("./vue-ui-chestnut-BIwKV_Me.js")),
      VueUiDashboard: e(() => import("./vue-ui-dashboard-BUHKjLLQ.js")),
      VueUiDigits: e(() => import("./vue-ui-digits-ZRwez97T.js")),
      VueUiDonut: e(() => import("./vue-ui-donut-bpO1nC_A.js")),
      VueUiDonutEvolution: e(() => import("./vue-ui-donut-evolution-P_70k4ZK.js")),
      VueUiGalaxy: e(() => import("./vue-ui-galaxy-BYqLQviQ.js")),
      VueUiGauge: e(() => import("./vue-ui-gauge-DwgxIcWn.js")),
      VueUiHeatmap: e(() => import("./vue-ui-heatmap-T0RZPJNi.js")),
      VueUiKpi: e(() => import("./vue-ui-kpi-BjHN5ees.js")),
      VueUiMiniLoader: e(() => import("./vue-ui-mini-loader-Dmoycj4D.js")),
      VueUiMolecule: e(() => import("./vue-ui-molecule-CmqUJWcJ.js")),
      VueUiMoodRadar: e(() => import("./vue-ui-mood-radar-Bfxtfqhs.js")),
      VueUiNestedDonuts: e(() => import("./vue-ui-nested-donuts-DhuIlTFL.js")),
      VueUiOnion: e(() => import("./vue-ui-onion-DqbR_fES.js")),
      VueUiQuadrant: e(() => import("./vue-ui-quadrant-D87ZPZhF.js")),
      VueUiRadar: e(() => import("./vue-ui-radar-DBvn8B7b.js")),
      VueUiRating: e(() => import("./vue-ui-rating-Dk4iTClP.js")),
      VueUiRelationCircle: e(() => import("./vue-ui-relation-circle-CTzPZrkc.js")),
      VueUiRings: e(() => import("./vue-ui-rings-Boi9uLxr.js")),
      VueUiScatter: e(() => import("./vue-ui-scatter-CM4upQYq.js")),
      VueUiScreenshot: e(() => import("./vue-ui-screenshot-B-bxd1nI.js")),
      VueUiSkeleton: e(() => import("./vue-ui-skeleton-C3iXaL49.js")),
      VueUiSmiley: e(() => import("./vue-ui-smiley-BtDsA0Zp.js")),
      VueUiSparkbar: e(() => import("./vue-ui-sparkbar-n0x0Ojvl.js")),
      VueUiSparkgauge: e(() => import("./vue-ui-sparkgauge-BwdfA6LO.js")),
      VueUiSparkHistogram: e(() => import("./vue-ui-sparkhistogram-BSlf36JQ.js")),
      VueUiSparkline: e(() => import("./vue-ui-sparkline-DSWvk3uJ.js")),
      VueUiSparkStackbar: e(() => import("./vue-ui-sparkstackbar-TtMuNP_L.js")),
      VueUiTable: e(() => import("./vue-ui-table-utOV9nTl.js")),
      VueUiTableSparkline: e(() => import("./vue-ui-table-sparkline-c9KUfM5n.js")),
      VueUiThermometer: e(() => import("./vue-ui-thermometer-D7NdF_tC.js")),
      VueUiTiremarks: e(() => import("./vue-ui-tiremarks-urcNYqvB.js")),
      VueUiTreemap: e(() => import("./vue-ui-treemap-D9FUy74E.js")),
      VueUiVerticalBar: e(() => import("./vue-ui-vertical-bar-ChHa19St.js")),
      VueUiWaffle: e(() => import("./vue-ui-waffle-DWZglOmM.js")),
      VueUiWheel: e(() => import("./vue-ui-wheel-MuAnDxyI.js")),
      VueUiXy: e(() => import("./vue-ui-xy-BwVbCW0Q.js")),
      VueUiTableHeatmap: e(() => import("./vue-ui-table-heatmap-DwHvhXeS.js")),
      VueUiAccordion: e(() => import("./vue-ui-accordion-B3F_RzZJ.js")),
      VueUiQuickChart: e(() => import("./vue-ui-quick-chart-B7cVyLVD.js")),
      VueUiCursor: e(() => import("./vue-ui-cursor-Bs22kPh_.js")),
      VueUiSparkTrend: e(() => import("./vue-ui-spark-trend-a1Y1HAcb.js")),
      VueUiStripPlot: e(() => import("./vue-ui-strip-plot-CeIaBpsB.js")),
      VueUiDumbbell: e(() => import("./vue-ui-dumbbell-BF4kFnaH.js")),
      VueUiWordCloud: e(() => import("./vue-ui-word-cloud-CrTlolf3.js")),
      VueUiXyCanvas: e(() => import("./vue-ui-xy-canvas-BtOoGLf9.js")),
      VueUiFlow: e(() => import("./vue-ui-flow-VejnWAwC.js")),
      VueUiParallelCoordinatePlot: e(() => import("./vue-ui-parallel-coordinate-plot-B5J5Xgsx.js")),
      VueUiTimer: e(() => import("./vue-ui-timer-BwFyHPOk.js")),
      VueUiCarouselTable: e(() => import("./vue-ui-carousel-table-OJ-EZXBN.js")),
      VueUiGizmo: e(() => import("./vue-ui-gizmo-CaIENr2y.js")),
      VueUiStackbar: e(() => import("./vue-ui-stackbar-DeIWk3RT.js")),
      VueUiBullet: e(() => import("./vue-ui-bullet-BE4BC3Lm.js"))
    }, $ = {
      VueUi3dBar: ["config", "dataset"],
      VueUiAgePyramid: ["config", "dataset"],
      VueUiAnnotator: ["config", "dataset"],
      VueUiCandlestick: ["config", "dataset"],
      VueUiChestnut: ["config", "dataset"],
      VueUiDashboard: ["config", "dataset"],
      VueUiDigits: ["config", "dataset"],
      VueUiDonut: ["config", "dataset"],
      VueUiDonutEvolution: ["config", "dataset"],
      VueUiGalaxy: ["config", "dataset"],
      VueUiGauge: ["config", "dataset"],
      VueUiHeatmap: ["config", "dataset"],
      VueUiKpi: ["config", "dataset"],
      VueUiMiniLoader: ["config"],
      VueUiMolecule: ["config", "dataset"],
      VueUiMoodRadar: ["config", "dataset"],
      VueUiNestedDonuts: ["config", "dataset"],
      VueUiOnion: ["config", "dataset"],
      VueUiQuadrant: ["config", "dataset"],
      VueUiRadar: ["config", "dataset"],
      VueUiRating: ["config", "dataset"],
      VueUiRelationCircle: ["config", "dataset"],
      VueUiRings: ["config", "dataset"],
      VueUiScatter: ["config", "dataset"],
      VueUiScreenshot: ["config"],
      VueUiSkeleton: ["config"],
      VueUiSmiley: ["config", "dataset"],
      VueUiSparkbar: ["config", "dataset"],
      VueUiSparkgauge: ["config", "dataset"],
      VueUiSparkHistogram: ["config", "dataset"],
      VueUiSparkline: ["config", "dataset"],
      VueUiSparkStackbar: ["config", "dataset"],
      VueUiTable: ["config", "dataset"],
      VueUiTableSparkline: ["config", "dataset"],
      VueUiThermometer: ["config", "dataset"],
      VueUiTiremarks: ["config", "dataset"],
      VueUiTreemap: ["config", "dataset"],
      VueUiVerticalBar: ["config", "dataset"],
      VueUiWaffle: ["config", "dataset"],
      VueUiWheel: ["config", "dataset"],
      VueUiXy: ["config", "dataset"],
      VueUiTableHeatmap: ["config", "dataset"],
      VueUiAccordion: ["config"],
      VueUiQuickChart: ["config", "dataset"],
      VueUiCursor: ["config"],
      VueUiSparkTrend: ["config", "dataset"],
      VueUiStripPlot: ["config", "dataset"],
      VueUiDumbbell: ["config", "dataset"],
      VueUiWordCloud: ["config", "dataset"],
      VueUiXyCanvas: ["config", "dataset"],
      VueUiFlow: ["config", "dataset"],
      VueUiParallelCoordinatePlot: ["config", "dataset"],
      VueUiTimer: ["config"],
      VueUiCarouselTable: ["config", "dataset"],
      VueUiGizmo: ["config", "dataset"],
      VueUiStackbar: ["config", "dataset"],
      VueUiBullet: ["config", "dataset"]
    }, g = c(() => !s[n.component]), j = c(() => s[n.component] || null), i = o(null), z = c(() => {
      const t = $[n.component] || [], a = {};
      return t.includes("config") && (a.config = Q.value), t.includes("dataset") && (a.dataset = X.value), a;
    }), p = o(() => null), m = o(() => null), d = o(() => null), V = o(() => null), U = o(() => null), f = o(() => null), v = o(() => null), h = o(() => null), k = o(() => null), S = o(() => null), b = o(() => null), y = o(() => null), T = o(() => null), A = o(() => null), C = o(() => null), P = o(() => null), D = o(() => null), x = o(() => null), L = o(() => null), _ = o(() => null), B = o(() => null), I = o(() => null), E = o(() => null), H = o(() => null);
    Y(() => {
      if (g.value)
        throw new Error(`

Vue Data UI exception:
The provided component "${n.component}" does not exist. Check the spelling.

Available components:

${Object.keys(s).map((t) => `. ${t}
`).join("")}`);
    }), O(i, async (t) => {
      t && (t.generatePdf && (p.value = t.generatePdf), t.generateImage && (d.value = t.generateImage), t.generateCsv && (m.value = t.generateCsv), t.getItemsPositions && (V.value = t.getItemsPositions), t.toggleReadonly && (U.value = t.toggleReadonly), t.shoot && (f.value = t.shoot), t.close && (v.value = t.close), t.restoreOrder && (h.value = t.restoreOrder), t.recalculateHeight && (k.value = t.recalculateHeight), t.toggleLock && (S.value = t.toggleLock), t.toggleTable && (b.value = t.toggleTable), t.toggleLabels && (y.value = t.toggleLabels), t.toggleSort && (T.value = t.toggleSort), t.toggleStack && (A.value = t.toggleStack), t.toggleTooltip && (C.value = t.toggleTooltip), t.start && (P.value = t.start), t.pause && (D.value = t.pause), t.reset && (x.value = t.reset), t.restart && (L.value = t.restart), t.lap && (_.value = t.lap), t.toggleAnimation && (B.value = t.toggleAnimation), t.pauseAnimation && (I.value = t.pauseAnimation), t.resumeAnimation && (E.value = t.resumeAnimation), t.toggleAnnotator && (H.value = t.toggleAnnotator));
    });
    const K = () => {
      const t = [
        "selectLegend",
        "selectDatapoint",
        "toggleOpenState",
        "saveAnnotations",
        "selectRoot",
        "selectBranch",
        "selectNut",
        "change",
        "selectPlot",
        "selectSide",
        "rate",
        "postImage",
        "hoverIndex",
        "selectX",
        "toggleLock",
        "toggleTooltip",
        "start",
        "pause",
        "reset",
        "restart",
        "lap",
        "toggleAnimation",
        "pauseAnimation",
        "resumeAnimation",
        "toggleAnnotator"
      ], a = {};
      return t.forEach((u) => {
        a[u] = (...l) => M(u, ...l);
      }), a;
    }, r = Z([]);
    return O([r, i], () => {
      if (i.value)
        for (; r.length; ) {
          const [t, ...a] = r.shift();
          typeof i.value[t] == "function" && i.value[t](...a);
        }
    }), G({
      getData: (...t) => i.value && typeof i.value.getData == "function" ? i.value.getData() : r.push(["getData", ...t]),
      generatePdf: p,
      generateCsv: m,
      generateImage: d,
      getItemsPositions: V,
      toggleReadonly: U,
      shoot: f,
      close: v,
      restoreOrder: h,
      recalculateHeight: k,
      toggleLock: S,
      toggleTable: b,
      toggleLabels: y,
      toggleSort: T,
      toggleStack: A,
      toggleTooltip: C,
      start: P,
      pause: D,
      reset: x,
      restart: L,
      lap: _,
      pauseAnimation: I,
      resumeAnimation: E,
      toggleAnimation: B,
      toggleAnnotator: H
    }), (t, a) => g.value ? (N(), R("div", Vt, [
      w("div", Ut, [
        tt(dt, {
          name: "moodFlat",
          stroke: "#FF0000"
        })
      ]),
      et(' The provided component "' + ot(it(W)) + '" does not exist ', 1)
    ])) : (N(), at(nt(j.value), rt({
      key: 1,
      ref_key: "currentComponentRef",
      ref: i
    }, z.value, lt(K())), st({ _: 2 }, [
      ut(t.$slots, (u, l) => ({
        name: l,
        fn: ct((q) => [
          gt(t.$slots, l, pt(mt(q)))
        ])
      }))
    ]), 1040));
  }
};
export {
  ht as default
};
